/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Performances           *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INCONCERT_CONTROLWIDGET_HPP__
#define INCONCERT_CONTROLWIDGET_HPP__

/* ControlWidget.hpp
   Gabriel M. Beddingfield
   2008-06-08

   Main GUI Dialog
*/

#include <QWidget>
#include <QSize>

class QPushButton;
class QLabel;
class QGridLayout;

namespace InConcert
{
class TimeBase;
class InConcertDlg;
class TimeBaseController;

class ControlWidget : public QWidget
{
    Q_OBJECT
public:
    ControlWidget(QWidget* parent, TimeBaseController* tb);

    virtual QSize sizeHint(void) const { return minimumSizeHint(); }

private:
    QLabel* m_tempo_lbl;
    QPushButton* m_tap_btn;
    QPushButton* m_cue;
    QPushButton* m_play;
    QPushButton* m_stop;
    QPushButton* m_skip_beat;
    QPushButton* m_insert_beat;
    QPushButton* m_re_zero;
    QPushButton* m_show_settings;

    TimeBaseController* m_tb;
    QGridLayout* m_layout;
}; /* class ControlWidget */

} /* namespace InConcert */

#endif // INCONCERT_CONTROLWIDGET_HPP__
