/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Perforances            *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version                                                               *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* TimebaseMaster.cpp
 * 2008-08-19
 */

#include <iostream>
#include "Client.hpp"
#include "TimebaseMaster.hpp"
#include <jack/jack.h>

using namespace std;
using namespace HiJack;

TimebaseMaster::TimebaseMaster(Client* client, const std::string& name) :
    m_client(0),
    m_name(name)
{
    if (client) {
        registerTimebaseMaster(client);
    }
}

TimebaseMaster::~TimebaseMaster()
{
    if (m_client) {
        unregisterTimebaseMaster();
    }
}

void TimebaseMaster::timebaseCallback(jack_transport_state_t /*state*/,
                                      jack_nframes_t /*nframes*/,
                                      jack_position_t* /*pos*/,
                                      int /*new_pos*/)
{
}

void TimebaseMaster::jackIsClosing(void) throw()
{
}

bool TimebaseMaster::registerTimebaseMaster(Client* client, bool if_none_already)
{
    bool rv = false;
    if (client) {
        rv = client->registerTimebaseMaster(this, if_none_already);
    }
    return rv;
}

bool TimebaseMaster::unregisterTimebaseMaster(void) throw()
{
    bool rv = false;
    if (m_client) {
        rv = m_client->unregisterTimebaseMaster(this);
    }
    return rv;
}
