/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Perforances            *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version                                                               *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HIJACK_TIMEBASEMASTER_HPP__
#define HIJACK_TIMEBASEMASTER_HPP__

/* TimebaseMaster.hpp
 *
 * Declares an interface that may be used as a Jack timebase master.
 */

#include <string>
#include <jack/transport.h>
#include <jack/types.h>

namespace HiJack
{
class Client;

class TimebaseMaster
{
    friend class HiJack::Client;

    Client* m_client;
    std::string m_name;
public:
    TimebaseMaster(Client* client = 0, const std::string& name = "");
    virtual ~TimebaseMaster();


    virtual const std::string& getName(void) { return m_name; }
    virtual void timebaseCallback(jack_transport_state_t state,
                                  jack_nframes_t nframes,
                                  jack_position_t *pos,
                                  int new_pos);
    virtual void jackIsClosing(void) throw();
    bool registerTimebaseMaster(Client* client, bool if_none_already = false);
    bool unregisterTimebaseMaster(void) throw();
};

} // namespace HiJack

#endif // HIJACK_TIMEBASEMASTER_HPP__
