/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Perforances            *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version                                                               *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* InConcert.cpp
   Gabriel M. Beddingfield
   2008-02-05

*/

#include "InConcertDlg.hpp"
#include <QtGui>
#include <QDebug>
#include <memory>
#include "ControlWidget.hpp"
#include "SettingsWidget.hpp"
#include "TimeBaseController.hpp"

using namespace InConcert;

InConcertDlg::InConcertDlg(QWidget* parent, TimeBase* tb) : QWidget(parent)
{
    m_tb = new TimeBaseController(this, tb);
    m_stack_lay = new QStackedLayout(this);
    m_stack_lay->setMargin(0);
    m_stack_lay->setSpacing(0);
    m_stack_lay->setSizeConstraint(QLayout::SetFixedSize);
    m_ctrl = new ControlWidget(this, m_tb);
    m_settings = new SettingsWidget(this, m_tb);

    m_stack_lay->addWidget(m_ctrl);
    m_stack_lay->addWidget(m_settings);
}

void InConcertDlg::switch_widget(void)
{
    int cur = m_stack_lay->currentIndex();
    ++cur;
    if(cur >= m_stack_lay->count()) {
        cur = 0;
    }
    m_stack_lay->setCurrentIndex(cur);
}

