/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Performances           *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INCONCERT_INCONCERTDLG_HPP__
#define INCONCERT_INCONCERTDLG_HPP__

/* InConcertDlg.hpp
   Gabriel M. Beddingfield
   2008-02-05

   Main GUI Dialog
*/

#include <QWidget>

class QPushButton;
class QStackedLayout;

namespace InConcert
{
class TimeBase;
class TimeBaseController;
class ControlWidget;
class SettingsWidget;

class InConcertDlg : public QWidget
{
    Q_OBJECT
public:
    InConcertDlg(QWidget* parent = 0, TimeBase* tb = 0);

public slots:
    void switch_widget(void);

private:
    TimeBaseController* m_tb;
    ControlWidget* m_ctrl;
    SettingsWidget* m_settings;
    QStackedLayout* m_stack_lay;
};

} /* namespace InConcert */

#endif // INCONCERT_INCONCERTDLG_HPP__
