/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Performances           *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INCONCERT_JACKMIDIIN_HPP__
#define INCONCERT_JACKMIDIIN_HPP__

/* JackMidiIn.hpp
   Gabriel M. Beddingfield
   2008-08-20

   Global definitions and prototypes.
*/

#include "HiJack/MidiInPort.hpp"
#include <jack/types.h>

namespace InConcert
{
class TimeBase;

class JackMidiIn : public HiJack::MidiInPort
{
    TimeBase *m_tb;
    byte m_chan;
public:
    JackMidiIn(TimeBase *_tb) :
        HiJack::MidiInPort("Midi:In"),
        m_tb(_tb),
        m_chan(0)
    { }
    virtual ~JackMidiIn();

    // Reimplemented handlers
    void handleControlChange(byte chan,
                             byte ctrl_no,
                             byte value,
                             jack_nframes_t frame);
};

} // namespace InConcert

#endif // INCONCERT_JACKMIDIIN_HPP__
