/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Performances           *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INCONCERT_SETTINGSWIDGET_HPP__
#define INCONCERT_SETTINGSWIDGET_HPP__

/* SettingsWidget.hpp
   Gabriel M. Beddingfield
   2008-02-05

*/

#include <QWidget>
#include <QSize>
#include "SettingsWidget.hpp"

class QLabel;
class QPushButton;
class QSpinBox;
class QDoubleSpinBox;

namespace InConcert
{
class TimeBaseController;
class InConcertDlg;

class SettingsWidget : public QWidget
{
public:
    SettingsWidget(QWidget* parent, TimeBaseController* tb);

    virtual QSize sizeHint(void) const { return minimumSizeHint(); }

private:
    TimeBaseController* m_timebase;

    QSpinBox* m_taps_required;
    QLabel* m_taps_required_label;
    QSpinBox* m_beats_per_measure;
    QLabel* m_beats_per_measure_label;
    QDoubleSpinBox* m_taps_timeout;
    QLabel* m_taps_timeout_label;

    QPushButton* m_show_controls;
};
}

#endif // INCONCERT_SETTINGSWIDGET_HPP__
